<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button class="btn btn-primary" [disabled]="formBuscar.invalid" (click)="search()">
    <i class="fa fa-search mr-2"></i>Buscar
  </button>
  <button class="btn btn-success ml-1" (click)="exportExcel()">
    <i class="far fa-file-excel mr-2"></i>Excel
  </button>
</app-page-title>

<div class="card">
  <div class="card-body" *ngIf="!loading">
    <form [formGroup]="formBuscar">
      <div class="row">
        <div class="form-group col-md-2 col-sm-2 col-lg-3">
          <label for="iagrup">Ing. Agrupado</label>
          <kendo-combobox [data]="dsIngagrp" [textField]="'cDesc'" [valueField]="'iagrp'" [filterable]="true"
            [valuePrimitive]="true" formControlName="iagrup" class="form-control">
          </kendo-combobox>
        </div>
        <div class="form-group col-md-2 col-sm-2">
          <label for="tperDesde">Desde</label>
          <kendo-datepicker [format]="formatKendo" class="form-control" formControlName="tperDesde"></kendo-datepicker>
        </div>
        <div class="form-group col-md-2 col-sm-2">
          <label for="tperDesde">Hasta</label>
          <kendo-datepicker [format]="formatKendo" class="form-control" formControlName="tperHasta"
            [min]="formBuscar.value.tperDesde">
          </kendo-datepicker>
        </div>
      </div>
    </form>

    <div class="row" *ngIf="dataGrid.length">
      <div id="tblExcel" class="col-12">
        <table class="table table-responsive">
          <tbody>
            <tr>
              <td>
                <div style="text-align: center; width: 18vh;">
                  <strong>Periodo</strong>
                </div>
              </td>
              <td *ngFor="let index of arrayIndex;">
                <div style="text-align: center;">
                  <strong>[{{ index }}]</strong>
                </div>
              </td>
            </tr>
            <ng-container *ngFor="let item of dataGrid; let i = index;">
              <tr style="line-height: 5vh;">
                <td style="text-align: center;">
                  <strong>{{ item.tper.substring(0, 4) }}-{{ item.tper.substring(4, 6) }}</strong>
                </td>
                <td *ngFor="let index of arrayIndex;">
                  <button class="btn-day btn" (click)="open(item.tper, index, modalHelp)"
                    [ngStyle]="{'color': returnColor(item['tsem' + index]), 'border': '1px solid' + returnColor(item['tsem' + index]) }"
                    *ngIf="item['tsem' + index]">
                    {{ item['tsem' + index] }}
                  </button>
                </td>
              </tr>
            </ng-container>
          </tbody>
        </table>
      </div>
    </div>
  </div>
  <app-loading *ngIf="loading"></app-loading>
</div>


<ng-template #modalHelp let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title">
      Semáforo {{ fechaSem | date: formatKendo }}
    </h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <kendo-grid [data]="semaforos" [selectable]="true" [navigable]="true" [sort]="sort" [sortable]="true"
      (edit)="assign($event)" (remove)="remove($event)" style="height: 60vh"
      (selectionChange)="selectRow($event)">
      <kendo-grid-column field="Descripcion" title="Descripción"></kendo-grid-column>
      <kendo-grid-column field="Semaforo" title="Semáforo"></kendo-grid-column>
      <kendo-grid-column field="cColor" title="Color">
        <ng-template kendoGridCellTemplate let-dataItem>
          <span [ngStyle]="{'background': dataItem.cColor }" class="template"> {{ dataItem.cColor }} </span>
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="sdefault" title="Default" width="120">
        <ng-template kendoGridCellTemplate let-dataItem>
          <input type="checkbox" [checked]="dataItem.sdefault" readonly />
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
        <ng-template kendoGridCellTemplate let-dataItem>
          <input type="checkbox" [checked]="dataItem.Inactivo" readonly />
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-command-column title="Acciones" width="220">
        <ng-template kendoGridCellTemplate let-isNew="isNew">
          <button kendoGridEditCommand [primary]="true">Asignar</button>
          <!-- <button kendoGridRemoveCommand>Quitar</button> -->
        </ng-template>
      </kendo-grid-command-column>
    </kendo-grid>
  </div>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click')">Cerrar</button>
  </div>
</ng-template>
